package br.com.evologica.mvp.ui.base;

import br.com.evologica.mvp.data.DataManager;

public class BasePresenter<V extends MvpView> implements MvpPresenter<V> {

    private V mMvpView;

    private final DataManager mDataManager;

    public BasePresenter(DataManager mDataManager) {
        this.mDataManager = mDataManager;
    }

    public V getMvpView() {
        return mMvpView;
    }

    @Override
    public void onAttach(V mvpView) {
        mMvpView = mvpView;
    }

    @Override
    public void onDetach() {
        mMvpView = null;
    }

    public boolean isViewAttached() {
        return mMvpView != null;
    }

    public DataManager getDataManager() {
        return mDataManager;
    }

}
