package br.com.evologica.mvp.ui.detailSensor;

import com.androidnetworking.error.ANError;
import com.androidnetworking.interfaces.JSONObjectRequestListener;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import br.com.evologica.mvp.data.DataManager;
import br.com.evologica.mvp.data.db.model.Stream;
import br.com.evologica.mvp.ui.base.BasePresenter;

/**
 * Created by marcussales on 02/10/2017.
 */

public class DetailSensorPresenter<V extends DetailSensorMvpView> extends BasePresenter<V> implements DetailSensorMvpPresenter<V> {

    public DetailSensorPresenter(DataManager mDataManager) {
        super(mDataManager);
    }

    @Override
    public void fetchStreams(int oidSensor) {
        getDataManager().getDetailSensor(oidSensor)
            .getAsJSONObject(new JSONObjectRequestListener() {
                @Override
                public void onResponse(JSONObject response) {
                    try {
                        JSONArray streams = response.getJSONArray("streams");

                        List<Stream> streamsModel = new ArrayList<>();
                        for(int i = 0; i < streams.length(); i++){
                            streamsModel.add(getDataManager().createStream(streams.getJSONObject(i)));
                        }
                        getMvpView().onFetchStreamsFinished(streamsModel);
                    } catch (JSONException e) {
                        getMvpView().onErrorFetchStreams(e.getMessage());
                    }
                }

                @Override
                public void onError(ANError anError) {
                    getMvpView().onErrorFetchStreams(anError.getMessage());
                }
            });
    }
}
