package br.com.evologica.mvp.ui.detailSensor;

import android.content.Context;
import android.content.Intent;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import java.util.List;

import br.com.evologica.mvp.R;
import br.com.evologica.mvp.data.db.model.Stream;
import br.com.evologica.mvp.ui.detailStream.DetailStreamActivity;

/**
 * Created by marcussales on 02/10/2017.
 */

public class StreamsAdapter extends RecyclerView.Adapter<StreamsAdapter.ViewHolder> {

    private List<Stream> listaStreams;
    private Context context;
    private final int sensorOid;

    public StreamsAdapter(List<Stream> listaStreams, Context context, int sensorOid) {
        this.listaStreams = listaStreams;
        this.context = context;
        this.sensorOid = sensorOid;
    }

    @Override
    public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(context).inflate(R.layout.stream_item, parent, false);
        return new ViewHolder(view);
    }

    @Override
    public void onBindViewHolder(ViewHolder holder, int position) {
        Stream stream = listaStreams.get(position);
        final int streamOid = stream.getOid();

        holder.nomeStream.setText(stream.getNome());
        holder.keyStream.setText(stream.getKey());

        holder.itemView.setOnClickListener(
            (view) -> {
                Intent intent = new Intent(context, DetailStreamActivity.class);
                intent.putExtra("SENSOR_OID", sensorOid);
                intent.putExtra("STREAM_OID", streamOid);
                context.startActivity(intent);
            }
        );
    }

    @Override
    public int getItemCount() {
        return listaStreams.size();
    }

    public class ViewHolder extends RecyclerView.ViewHolder {

        TextView nomeStream;
        TextView keyStream;

        public ViewHolder(View itemView) {
            super(itemView);

            nomeStream = (TextView) itemView.findViewById(R.id.stream_name);
            keyStream = (TextView) itemView.findViewById(R.id.stream_key);
        }
    }
}
