package br.com.evologica.mvp.ui.detailStream;

import com.androidnetworking.error.ANError;
import com.androidnetworking.interfaces.JSONObjectRequestListener;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import br.com.evologica.mvp.data.DataManager;
import br.com.evologica.mvp.data.db.model.StreamData;
import br.com.evologica.mvp.ui.base.BasePresenter;

/**
 * Created by marcussales on 02/10/2017.
 */

public class DetailStreamPresenter<V extends DetailStreamMvpView> extends BasePresenter<V> implements DetailStreamMvpPresenter<V> {

    public DetailStreamPresenter(DataManager mDataManager) {
        super(mDataManager);
    }

    @Override
    public void fetchStreamsData(int sensorOid, int streamOid) {
        getDataManager().getDetailStream(sensorOid, streamOid)
            .getAsJSONObject(new JSONObjectRequestListener() {
                @Override
                public void onResponse(JSONObject response) {
                    try {
                        JSONArray streams = response.getJSONArray("data");
                        List<StreamData> streamsModel = new ArrayList<>();
                        for(int i = 0; i < streams.length(); i++){
                            streamsModel.add(getDataManager().createStreamData(streams.getJSONObject(i)));
                        }
                        getMvpView().onFetchStreamsDataFinished(streamsModel);
                    } catch (JSONException e) {
                        getMvpView().onErrorFetchStreamsData(e.getMessage());
                    }
                }

                @Override
                public void onError(ANError anError) {
                    getMvpView().onErrorFetchStreamsData(anError.getMessage());
                }
            });
    }
}
