package br.com.evologica.mvp.ui.detailStream;

import android.content.Context;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import java.text.SimpleDateFormat;
import java.util.List;
import java.util.Locale;

import br.com.evologica.mvp.R;
import br.com.evologica.mvp.data.db.model.StreamData;

/**
 * Created by marcussales on 02/10/2017.
 */

public class StreamDataAdapter extends RecyclerView.Adapter<StreamDataAdapter.ViewHolder> {

    private List<StreamData> listaDadosStream;
    private Context context;

    public StreamDataAdapter(List<StreamData> listaDadosStream, Context context) {
        this.listaDadosStream = listaDadosStream;
        this.context = context;
    }

    @Override
    public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(context).inflate(R.layout.stream_data_item, parent, false);
        return new ViewHolder(view);
    }

    @Override
    public void onBindViewHolder(ViewHolder holder, int position) {
        StreamData streamData = listaDadosStream.get(position);

        SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy", Locale.getDefault());
        holder.streamTimestamp.setText(format.format(streamData.getDate()));
        holder.streamValue.setText(streamData.getValue());
    }

    @Override
    public int getItemCount() {
        return listaDadosStream.size();
    }

    public class ViewHolder extends RecyclerView.ViewHolder {

        TextView streamTimestamp;
        TextView streamValue;

        public ViewHolder(View itemView) {
            super(itemView);

            streamTimestamp = (TextView) itemView.findViewById(R.id.stream_item_timestamp);
            streamValue = (TextView) itemView.findViewById(R.id.stream_item_value);
        }
    }
}
