package br.com.evologica.mvp.ui.main;

import com.androidnetworking.error.ANError;
import com.androidnetworking.interfaces.JSONArrayRequestListener;

import org.json.JSONArray;
import org.json.JSONException;

import java.util.ArrayList;
import java.util.List;

import br.com.evologica.mvp.data.DataManager;
import br.com.evologica.mvp.data.db.model.Sensor;
import br.com.evologica.mvp.ui.base.BasePresenter;

public class MainPresenter<V extends MainMvpView> extends BasePresenter<V> implements MainMvpPresenter<V> {

    public MainPresenter(DataManager dataManager) {
        super(dataManager);
    }

    @Override
    public void fetchSensors() {
        getDataManager().getAllStreams()
            .getAsJSONArray(new JSONArrayRequestListener() {
                @Override
                public void onResponse(JSONArray response) {
                    try {
                        List<Sensor> sensores = new ArrayList<>();
                        for(int i = 0; i < response.length(); i++){
                            sensores.add(getDataManager().createSensor(response.getJSONObject(i)));
                        }
                        getMvpView().onFetchSensorsFinished(sensores);
                    } catch (JSONException e) {
                        getMvpView().onErrorFetchSensors(e.getMessage());
                    }
                }

                @Override
                public void onError(ANError anError) {
                    getMvpView().onErrorFetchSensors(anError.getMessage());
                }
            });
    }
}
