package br.com.evologica.mvp.ui.main;

import android.content.Context;
import android.content.Intent;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import java.util.List;

import br.com.evologica.mvp.R;
import br.com.evologica.mvp.data.db.model.Sensor;
import br.com.evologica.mvp.ui.detailSensor.DetailSensorActivity;

/**
 * Created by marcussales on 02/10/2017.
 */

public class SensoresAdapter extends RecyclerView.Adapter<SensoresAdapter.ViewHolder> {

    private List<Sensor> listaSensores;
    private Context context;

    public SensoresAdapter(List<Sensor> listaSensores, Context context) {
        this.listaSensores = listaSensores;
        this.context = context;
    }

    @Override
    public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(context).inflate(R.layout.sensor_item, parent, false);
        return new ViewHolder(view);
    }

    @Override
    public void onBindViewHolder(ViewHolder holder, int position) {
        Sensor sensor = listaSensores.get(position);
        final String nomeSensor = sensor.getNome();
        final int sensorOid = sensor.getOid();

        holder.nomeSensor.setText(nomeSensor);
        holder.keySensor.setText(sensor.getKey());

        String streamNumber = sensor.getStreamNumber() + " streams";
        holder.numeroStreams.setText(streamNumber);

        holder.itemView.setOnClickListener(
            (view) -> {
                Intent intent = new Intent(context, DetailSensorActivity.class);
                intent.putExtra("SENSOR_NAME", nomeSensor);
                intent.putExtra("SENSOR_OID", sensorOid);
                context.startActivity(intent);
            }
        );
    }

    @Override
    public int getItemCount() {
        return listaSensores.size();
    }

    public class ViewHolder extends RecyclerView.ViewHolder {

        TextView nomeSensor;
        TextView keySensor;
        TextView numeroStreams;

        public ViewHolder(View itemView) {
            super(itemView);

            nomeSensor = (TextView) itemView.findViewById(R.id.sensor_name);
            keySensor = (TextView) itemView.findViewById(R.id.sensor_key);
            numeroStreams = (TextView) itemView.findViewById(R.id.streams_number);
        }
    }
}
